function [left, right, center] = allocateHolesWithBolts(drillPlan, boltPlan)
    [x,y,z,typeOfHole] = getDrillPlan3D(drillPlan);
    xy = [x,y,z];
    for i=1:length(x)
        if typeOfHole(i) == 'Reference'
            if i==length(x)
                xy = [xy(1:i-1,:)];
            elseif i==1
                xy = [xy(2:end,:)];
            else
                xy = [xy(1:i-1,:);xy(i+1:end,:)];
            end
        end
    end
    odd = false;
    divThree = false;
    if mod(length(xy),2) == 1
        odd = true;
    end
    if mod(length(xy),3) == 0
        divThree = true;
    end

    lineX = 0;

    xy = sortrows(xy,1);
    if odd
        mid = ceil(length(xy)/2);
        left = xy(1:mid,:);
        right = xy(mid+1:end,:);
        lineX = xy(mid,1);
    else
        mid = length(xy)/2;
        left = xy(1:mid,:);
        right = xy(mid+1:end,:);
        lineX = (xy(mid,1) + xy(mid,1))/2;
    end

    centerPoint = [lineX 0 0];


    i = findClosest3D(left,centerPoint);
    center = left(i,:);
    left = removeFromArray(left,i);

    finished = false;

    while ~finished
        if divThree
            if length(left) == length(right) && length(left) == length(center)
                finished = true;
            else
                if length(left) >= length(right)
                    i = findClosest3D(left,centerPoint);
                    center(end+1,:) = left(i,:);
                    left = removeFromArray(left,i);
                else
                    i = findClosest3D(right,centerPoint);
                    center(end+1,:) = right(i,:);
                    right = removeFromArray(right,i);
                end
            end
        else
            l = length(left);
            r = length(right);
            c = length(center);
            if (l<=r+1 && l>=r-1) && (l<=c+1 && l>=c-1) && (c<=r+c && c>=r-c)
                finished = true;
            else
                if length(left) >= length(right)
                    i = findClosest3D(left,centerPoint);
                    center(end+1,:) = left(i,:);
                    left = removeFromArray(left,i);
                else
                    i = findClosest3D(right,centerPoint);
                    center(end+1,:) = right(i,:);
                    right = removeFromArray(right,i);
                end
            end
        end
    end
    [x_b,y_b,z_b,typeOfHole_b] = getDrillPlan3D(boltPlan);
    for i=1:length(x_b)
        if typeOfHole_b(i) == 'Reference'
            if i==length(x_b)
                x_b = [x_b(1:i-1,:)];
                y_b = [y_b(1:i-1,:)];
                z_b = [z_b(1:i-1,:)];
            elseif i==1
                x_b = [x_b(2:end,:)];
                y_b = [y_b(2:end,:)];
                z_b = [z_b(2:end,:)];
            else
                x_b = [x_b(1:i-1,:);x_b(i+1:end,:)];
                y_b = [y_b(1:i-1,:);y_b(i+1:end,:)];
                z_b = [z_b(1:i-1,:);z_b(i+1:end,:)];
            end
        end
    end
    
    xyz_bolts = [[x_b;x_b],[y_b;y_b],[z_b;z_b]];
    xyz_bolts(1:length(x_b),2) = -2;
    xyz_bolts(length(x_b)+1:end,2) = -4;
    xyz_bolts = sortrows(xyz_bolts,1);
    j=(length(xyz_bolts)-mod(length(xyz_bolts),3))/3;
    
    left = [left;xyz_bolts(1:j,:)];
    center = [center;xyz_bolts(j+1:2*j,:)];
    right = [right;xyz_bolts(2*j+1:end,:)];
end
