function subTours = detectSubtours(x,idxs)
% Returns a cell array of subtours. The first subtour is the first row of x, etc.

%   Copyright 2014 The MathWorks, Inc. 

x = round(x); % correct for not-exactly integers
r = find(x); % indices of the trips that exist in the solution
substuff = idxs(r,:); % the collection of node pairs in the solution
unvisited = ones(length(r),1); % keep track of places not yet visited
curr = 1; % subtour we are evaluating
startour = find(unvisited,1); % first unvisited trip
    while ~isempty(startour)
        home = substuff(startour,1); % starting point of subtour
        nextpt = substuff(startour,2); % next point of tour
        visited = nextpt; unvisited(startour) = 0; % update unvisited points
        while nextpt ~= home
            % Find the other trips that starts at nextpt
            [srow,scol] = find(substuff == nextpt);
            % Find just the new trip
            trow = srow(srow ~= startour);
            scol = 3-scol(trow == srow); % turn 1 into 2 and 2 into 1
            startour = trow; % the new place on the subtour
            nextpt = substuff(startour,scol); % the point not where we came from
            if isempty(nextpt)
                visited = [home,visited];
            end
            visited = [visited,nextpt]; % update nodes on the subtour
            unvisited(startour) = 0; % update unvisited
        end
        subTours{curr} = visited; % store in cell array
        curr = curr + 1; % next subtour
        startour = find(unvisited,1); % first unvisited trip
    end
    for i=1:(length(subTours)-1)
        if i<=(length(subTours)-1)
            for j=(i+1):length(subTours)
                if j<=length(subTours)
                    first = cell2mat(subTours(1,i));
                    second = cell2mat(subTours(1,j));
                    if first(1) == second(1)
                        newTour = [fliplr(first(2:end)) second];
                        counter = 1;
                        newTours = {};
                        for k=1:length(subTours)
                            if k~=i && k~=j
                                newTours{counter} = cell2mat(subTours(1,k));
                                counter = counter + 1;
                            end
                        end
                        newTours{counter} = newTour;
                        subTours = newTours;
                    elseif first(1) == second(end)
                        newTour = [second(1:end-1) first];
                        counter = 1;
                        newTours = {};
                        for k=1:length(subTours)
                            if k~=i && k~=j
                                newTours{counter} = cell2mat(subTours(1,k));
                                counter = counter + 1;
                            end
                        end
                        newTours{counter} = newTour;
                        subTours = newTours;
                    elseif first(end) == second(1)
                        newTour = [first(1:end-1) second];
                        counter = 1;
                        newTours = {};
                        for k=1:length(subTours)
                            if k~=i && k~=j
                                newTours{counter} = cell2mat(subTours(1,k));
                                counter = counter + 1;
                            end
                        end
                        newTours{counter} = newTour;
                        subTours = newTours;
                    elseif first(end) == second(end)
                        newTour = [first(1:end-1) fliplr(second)];
                        counter = 1;
                        newTours = {};
                        for k=1:length(subTours)
                            if k~=i && k~=j
                                newTours{counter} = cell2mat(subTours(1,k));
                                counter = counter + 1;
                            end
                        end
                        newTours{counter} = newTour;
                        subTours = newTours;
                    end
                end
            end
        end
    end
    
end