[x,y,typeOfHole] = getDrillPlan('C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml');
f = figure;
hold on
for i=1:length(x)
    switch typeOfHole(i)
        case 'BoltHole'
            p1 = scatter(x(i),y(i),'y');
        case 'Bottom'
            p2 = scatter(x(i),y(i),'c');
        case 'EasersHole'
            p3 = scatter(x(i),y(i),'b');
        case 'Contour'
            p4= scatter(x(i),y(i),'r');
        case 'SecondContour'
            p5 = scatter(x(i),y(i),'g');
        case 'CutHole'
            p6 = scatter(x(i),y(i),'m');
        case 'Reference'
            p7 = scatter(x(i),y(i),[],[1 0.5 0]);
        case 'ReamingHole'
            p8 = scatter(x(i),y(i),96,[0.5 0.5 0.5]);
        otherwise
            p9 = scatter(x(i),y(i),'black');
    end
end
set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
legend([p1 p2 p3 p4 p5 p6 p7 p8],{'BoltHole','Bottom','EasersHole','Contour','SecondContour','CutHole','Reference','ReamingHole'});
title('Drill plan with hole types','FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_plan_hole_types.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_plan_hole_types.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_plan_hole_types.eps'),'epsc');