clear;
drillPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml';
[left,right,center] = allocateHoles(drillPlan);
% f1 = figure;
% hold on
% p1 = scatter(left(:,1),left(:,2),'r');
% p2 = scatter(center(:,1),center(:,2),'g');
% p3 = scatter(right(:,1),right(:,2),'b');
% hold off
% set(f1,'Units','Pixels');
% set(f1, 'OuterPosition', [0, 0, 1500, 1200]);
% grid on
% title('Allocated holes','FontSize',48);
% xlabel('Distance [m]','FontSize',24);
% ylabel('Distance [m]','FontSize',24);
% set(gca,'FontSize',16)
% ax = gca;
% outerpos = ax.OuterPosition;
% ti = ax.TightInset; 
% left_m = outerpos(1) + ti(1);
% bottom = outerpos(2) + ti(2);
% ax_width = outerpos(3) - ti(1) - ti(3);
% ax_height = outerpos(4) - ti(2) - ti(4);
% ax.Position = [left_m bottom ax_width ax_height];
% legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});

f = figure;
hold on
p1 = scatter(left(:,1),left(:,2),'r');
p2 = scatter(center(:,1),center(:,2),'g');
p3 = scatter(right(:,1),right(:,2),'b');
%%
distance = 0;
minDistance = 3;

[first,second,dist] = getMaxDistance(center);
[start1, stop1] = getShortestPathWithoutCollision(center,first,second,[],[],minDistance);
boom2 = [start1;stop1(end,:)];
for i=1:length(start1)
    q = quiver(start1(i,1),start1(i,2),stop1(i,1)-start1(i,1),stop1(i,2)-start1(i,2),'AutoScale','off','MaxHeadSize',1);
    q.Color = [0.5 1 0.5];
end
for i=1:size(boom2,1)
    dx = 0.1;
    dy = 0.1;
    text(boom2(i,1)+dx,boom2(i,2)+dy,int2str(i));
end
distance2 = calculateDistance(start1, stop1);

[start2, stop2] = getShortestPathWithoutCollision(left,0,0,start1,[],minDistance);
boom1 = [start2;stop2(end,:)];
for i=1:length(start2)
    q = quiver(start2(i,1),start2(i,2),stop2(i,1)-start2(i,1),stop2(i,2)-start2(i,2),'AutoScale','off','MaxHeadSize',1);
    q.Color = [1 0.5 0.5];
end
for i=1:size(boom1,1)
    dx = 0.1;
    dy = 0.1;
    text(boom1(i,1)+dx,boom1(i,2)+dy,int2str(i));
end
distance1 = calculateDistance(start2, stop2);

[start3, stop3] = getShortestPathWithoutCollision(right,0,0,start1,start2,minDistance);
boom3 = [start3;stop3(end,:)];
for i=1:length(start3)
    q = quiver(start3(i,1),start3(i,2),stop3(i,1)-start3(i,1),stop3(i,2)-start3(i,2),'AutoScale','off','MaxHeadSize',1);
    q.Color = [0.5 0.5 1];
end
for i=1:size(boom3,1)
    dx = 0.1;
    dy = 0.1;
    text(boom3(i,1)+dx,boom3(i,2)+dy,int2str(i));
end
distance3 = calculateDistance(start3, stop3);
distanceTot = distance1 + distance2 + distance3;
distanceNormalized = distance/(size(left,1)+size(center,1)+size(right,1));




set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title(strcat('Optimal drill sequence'),'FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left_m = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left_m bottom ax_width ax_height];
legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});

saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision',int2str(minDistance),'.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision',int2str(minDistance),'.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision',int2str(minDistance),'.eps'),'epsc');

% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.png'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.fig'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.eps'),'epsc');