clear;
drillPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml';
boltPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\Bolteplan Klasse C pel 13960-14410 Stigende.xml';

[left, right, center] = allocateHolesWithBolts(drillPlan,boltPlan);
% f1 = figure;
% hold on
% p1 = scatter(left(:,1),left(:,2),'r');
% p2 = scatter(center(:,1),center(:,2),'g');
% p3 = scatter(right(:,1),right(:,2),'b');
% hold off
% set(f1,'Units','Pixels');
% set(f1, 'OuterPosition', [0, 0, 1500, 1200]);
% grid on
% title('Allocated holes','FontSize',48);
% xlabel('Distance [m]','FontSize',24);
% ylabel('Distance [m]','FontSize',24);
% set(gca,'FontSize',16)
% ax = gca;
% outerpos = ax.OuterPosition;
% ti = ax.TightInset; 
% left_m = outerpos(1) + ti(1);
% bottom = outerpos(2) + ti(2);
% ax_width = outerpos(3) - ti(1) - ti(3);
% ax_height = outerpos(4) - ti(2) - ti(4);
% ax.Position = [left_m bottom ax_width ax_height];
% legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});

f = figure;

p1 = scatter3(left(:,1),left(:,2),left(:,3),'r');
hold on
p2 = scatter3(center(:,1),center(:,2),center(:,3),'g');
p3 = scatter3(right(:,1),right(:,2),right(:,3),'b');
daspect([1 0.5 1]);
%%
distance = 0;
minDistance = 0;

[first,second,dist] = getMaxDistance3D(center);
[start1, stop1] = getShortestPathWithoutCollision3D(center,first,second,[],[],minDistance);
boom2 = [start1;stop1(end,:)];
for i=1:length(start1)
    q = quiver3(start1(i,1),start1(i,2),start1(i,3),stop1(i,1)-start1(i,1),stop1(i,2)-start1(i,2),stop1(i,3)-start1(i,3),'AutoScale','off','MaxHeadSize',1);
    q.Color = [0.5 1 0.5];
end
% for i=1:size(boom2,1)
%     dx = 0.1;
%     dy = 0.1;
%     text(boom2(i,1)+dx,boom2(i,2)+dy,int2str(i));
% end
distance = distance + calculateDistance3D(start1, stop1);

[start2, stop2] = getShortestPathWithoutCollision3D(left,0,0,start1,[],minDistance);
boom1 = [start2;stop2(end,:)];
for i=1:length(start2)
    q = quiver3(start2(i,1),start2(i,2),start2(i,3),stop2(i,1)-start2(i,1),stop2(i,2)-start2(i,2),stop2(i,3)-start2(i,3),'AutoScale','off','MaxHeadSize',1);
    q.Color = [1 0.5 0.5];
end
% for i=1:size(boom1,1)
%     dx = 0.1;
%     dy = 0.1;
%     text(boom1(i,1)+dx,boom1(i,2)+dy,int2str(i));
% end
distance = distance + calculateDistance3D(start2, stop2);

[start3, stop3] = getShortestPathWithoutCollision3D(right,0,0,start1,start2,minDistance);
boom3 = [start3;stop3(end,:)];
for i=1:length(start3)
    q = quiver3(start3(i,1),start3(i,2),start3(i,3),stop3(i,1)-start3(i,1),stop3(i,2)-start3(i,2),stop3(i,3)-start3(i,3),'AutoScale','off','MaxHeadSize',1);
    q.Color = [0.5 0.5 1];
end
% for i=1:size(boom3,1)
%     dx = 0.1;
%     dy = 0.1;
%     text(boom3(i,1)+dx,boom3(i,2)+dy,int2str(i));
% end
distance = distance + calculateDistance3D(start3, stop3);
distanceNormalized = distance/(size(left,1)+size(center,1)+size(right,1));




set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
view([-1.5,1,1])
grid on
legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'},'Location','northeast','FontSize',16);
title(strcat('Optimal drill sequence with bolt holes'),'FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left_m = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left_m bottom ax_width ax_height];


saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision3D',int2str(minDistance),'.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision3D',int2str(minDistance),'.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Optimal_drill_sequence_collision3D',int2str(minDistance),'.eps'),'epsc');

% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.png'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.fig'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.eps'),'epsc');