clear;

%% Load data
drillPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml';
[left,right,center] = allocateHoles(drillPlan);

%% Plot points
f = figure;
set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Uneven hol allocation','FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left_m = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left_m bottom ax_width ax_height];

center = [center;left(40,:);left(42,:);left(43,:)];
left = [left(1:39,:);left(41,:);left(44:end,:)];

hold on
p1 = scatter(left(:,1),left(:,2),'r');
p2 = scatter(center(:,1),center(:,2),'g');
p3 = scatter(right(:,1),right(:,2),'b');
legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'},'Location','northeast','FontSize',16);
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','uneven.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','uneven.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','uneven.eps'),'epsc');
% for i=1:length(left)
%     dx = 0.1;
%     dy = 0.1;
%     text(left(i,1)+dx,left(i,2)+dy,int2str(i));
% end

%% Plot points
[left, center, right] = reAllocateHoles(left, center, right, [0,0], [0,0], [0,0]);
f1 = figure;
set(f1,'Units','Pixels');
set(f1, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Reallocated holes','FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left_m = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left_m bottom ax_width ax_height];

hold on
p11 = scatter(left(:,1),left(:,2),'r');
p21 = scatter(center(:,1),center(:,2),'g');
p31 = scatter(right(:,1),right(:,2),'b');
legend([p11 p21 p31],{'Boom 1','Boom 2','Boom 3'},'Location','northeast','FontSize',16);
saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','even.png'));
saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','even.fig'));
saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','even.eps'),'epsc');

